package cn.nhyw.yjjl.action;

 import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.excel.ExcelCol;
import cn.base.excel.ExportEngine;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.LogConstants;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;
import cn.nhyw.gysgl.service.NhywgysxxService;
import cn.nhyw.yjjl.service.NhywgyssbyjdzjkService;

@SuppressWarnings({"all"})
@Component("nhywgyssbyjdzjkAction")
public class NhywgyssbyjdzjkAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(NhywgyssbyjdzjkAction.class);
	
	@Autowired
	private NhywgyssbyjdzjkService service;
	@Autowired
	private NhywgysxxService gysxxService;
	
	
	/**
	 * 分页
	 */
	/*
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="listNhywgyssbyjdzjkByPage")
	public void listNhywgyssbyjdzjkByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listNhywgyssbyjdzjkByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-listNhywgyssbyjdzjkByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 查询总数
	 */
	/*
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Nhywgyssbyjdzjk")
	public void count_Nhywgyssbyjdzjk(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Nhywgyssbyjdzjk(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-count_Nhywgyssbyjdzjk-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 查询 Nhywgyssbyjdzjk
	 */
	/*
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Nhywgyssbyjdzjk")
	public void query_Nhywgyssbyjdzjk(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Nhywgyssbyjdzjk(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-query_Nhywgyssbyjdzjk-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 查询 一条Nhywgyssbyjdzjk
	 */
	/*
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Nhywgyssbyjdzjk")
	public void get_Nhywgyssbyjdzjk(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Nhywgyssbyjdzjk(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkActionquery_Nhywgyssbyjdzjk-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="deleteNhywgyssbyjdzjk")
	public void delete_Nhywgyssbyjdzjk(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {			
			// 1.删除移交单
			int result = service.delete_Nhywgyssbyjdzjk(map);
			// 2.更新 gysxx 表记录
			gysxxService.update_Nhywgysxx(map);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-delete_Nhywgyssbyjdzjk-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}


	/**
	 * 插入
	 */
	
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Nhywgyssbyjdzjk")
	public void insert_Nhywgyssbyjdzjk(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			
			// 1.数据入库
			if(StringUtil.checkEmpty(map.get("xh"))){
				map.put("xh",StringUtil.getUUID());
			}
			service.insert_Nhywgyssbyjdzjk(map);
			
			// 2.更新 nhywgysxx 表
			String yjgysbh = (String) map.get("yjgysbh");
			String jsgysbh = (String) map.get("jsgysbh");
			String yjjhbh = (String) map.get("yjjhbh");
			
			Map editMap = new HashMap();
			editMap.put("XGTJxh", yjgysbh);
			editMap.put("kz1", " ");
			gysxxService.update_Nhywgysxx(editMap);				// 更新移交供应商信息
			
			editMap.clear();
			editMap.put("XGTJxh", jsgysbh);
			editMap.put("kz1", yjjhbh);
			gysxxService.update_Nhywgysxx(editMap);	          // 更新接收供应商信息
			
			Struts2Utils.renderJson(Constants.SUCCESS);			
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-insert_Nhywgyssbyjdzjk()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 修改
	 */
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Nhywgyssbyjdzjk")
	public void update_Nhywgyssbyjdzjk(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			
			int result = service.update_Nhywgyssbyjdzjk(map);
			Struts2Utils.renderJson(Constants.SUCCESS);
			
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-update_Nhywgyssbyjdzjk-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 批量删除
	 */
	/*
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Nhywgyssbyjdzjk")
	public void batch_delete_Nhywgyssbyjdzjk(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword").toString());
			int result = service.batch_delete_Nhywgyssbyjdzjk(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-batch_delete_Nhywgyssbyjdzjk-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 导出Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Nhywgyssbyjdzjk")
	public void exp_Nhywgyssbyjdzjk(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Nhywgyssbyjdzjk(map);		
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("yhzh", m.get("yhzh"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 2;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"yhzh", "yhmc",};
			String[] zdmc = {"用户账号", "用户名称"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "供应商设备移交单关联电子监控设备-"+dateTime);
			params.put("sheetName", "供应商设备移交单关联电子监控设备");
			params.put("header", "供应商设备移交单关联电子监控设备");	
			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywgyssbyjdzjkAction-exoprtExcel-error:" +e);
			
		}
	}
	*/
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Nhywgyssbyjdzjk")
	public String imp_Nhywgyssbyjdzjk(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("NhywgyssbyjdzjkAction-imp_Nhywgyssbyjdzjk-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
	
	
}
